'Compilable Example:
'Based on Florent Heyworth's PB code and MSDN
'Original code for writing of links was from Semen Matusovski
'Modified by George Bleck for reading of links

#Compile Exe "gbclipopen9.exe"
#Dim All
#Include "win32api.inc"
#Resource Icon, 400, "images\gbclipopen9.ico"

$ver = "1.0"

Declare Function Sub1( p1 As Any ) As Dword
Declare Function Sub2( p1 As Any, p2 As Any ) As Dword
Declare Function Sub3( p1 As Any, p2 As Any, p3 As Any ) As Dword
Declare Function Sub5( p1 As Any, p2 As Any, p3 As Any, p4 As Any, p5 As Any ) As Dword

Function PBMain() As Long
   Local ClipBoardText$, codeFileName, appFileName As AsciiZ * %Max_Path, iResult As Dword, cmd$, drop$
   appFileName = "c:\pbwin90\bin\pbedit.exe"
   If Len(Command$) Then
       cmd$ = Command$
       Replace """" With "" In cmd$
       If Right$(LCase$(cmd$),4) = ".lnk" Then cmd$ = GetLinkInfo(cmd$)
       iResult = Shell(appFileName$ + " " + cmd$)
   Else
       codeFileName = Exe.Path$ + "gbclipopen_temp.bas"
       Clipboard Get Text To ClipBoardText$
       Open codeFileName For Output As #1
       Print #1, ClipBoardText$
       Close #1
       iResult = Shell(appFileName$ + " " + codeFileName)
   End If
End Function

Function GetLinkInfo(LinkPath As String ) As String
   Local CLSID_ShellLink, IID_IShellLink As GUIDAPI
   Local CLSCTX_INPROC_SERVER, Flags, lResult As Dword
   Local FileData As WIN32_FIND_DATA
   Local IID_Persist As String * 16
   Local pp, ppf, psl As Dword Ptr
   Local TmpAsciiz As AsciiZ * %Max_Path
   Local TmpWide As AsciiZ * ( 2 * %Max_Path )
   Local outvalue As AsciiZ * %Max_Path  '128

   Poke$ VarPtr(CLSID_ShellLink), Mkl$( &H00021401 ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   Poke$ VarPtr(IID_IShellLink), Mkl$( &H000214EE ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )

   IID_Persist = Mkl$( &H0000010B ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   CLSCTX_INPROC_SERVER = 1
   CoInitialize ByVal %NULL

   If IsFalse( CoCreateInstance(CLSID_ShellLink, ByVal %NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, psl )) Then
      pp = @psl: Call Dword @pp Using Sub3( ByVal psl, IID_Persist, ppf ) To lResult
      TmpAsciiz = LinkPath
      MultiByteToWideChar %CP_ACP, 0, TmpAsciiz, %Max_Path, ByVal VarPtr(TmpWide), 2 * %Max_Path
      pp = @ppf + 20: Call Dword @pp Using Sub3( ByVal ppf, TmpWide, ByVal %TRUE )
      pp = @psl + 12: Call Dword @pp Using Sub5( ByVal psl, outvalue, ByVal %Max_Path, FileData, Flags )  'GetFilePath
      pp = @ppf + 8: Call Dword @pp Using Sub1( ByVal ppf )      'Release the persistant file
      pp = @psl + 8: Call Dword @pp Using Sub1( ByVal psl )      'Unbind the shell link object from the persistent file
      Function = outvalue
   End If
   CoUninitialize
End Function
